﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace sl_Chart_763582
{
    public partial class MainPage : UserControl
    {
        new List<PlotInfo> data;
        public MainPage()
        {
            InitializeComponent();

            this.DataContext = this.data = new List<PlotInfo> 
            { 
                new PlotInfo { YVal = 1, BubbleSizeVal = 33 },
                new PlotInfo { YVal = 2, BubbleSizeVal = 2 },
                new PlotInfo { YVal = 3, BubbleSizeVal = 3 },
                new PlotInfo { YVal = 4, BubbleSizeVal = 4 },
            };

            //var asd = this.chart1.DefaultView.ChartArea.AxisX.ConvertPhysicalUnitsToData(30) - this.chart1.DefaultView.ChartArea.AxisX.ConvertPhysicalUnitsToData(0);

            this.chart1.DefaultView.ChartArea.AxisX.RangeChanged += this.AxisX_RangeChanged;
            this.chart1.SizeChanged += chart1_SizeChanged;
        }

        void chart1_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            this.chart1.DefaultView.ChartArea.AxisY.AutoRange = true;
            this.Dispatcher.BeginInvoke(() => this.UpdateAxisRange());
        }

        void AxisX_RangeChanged(object sender, EventArgs e)
        {
            this.Dispatcher.BeginInvoke(() => this.UpdateAxisRange());
        }

        private void UpdateAxisRange()
        {
            if (!this.chart1.DefaultView.ChartArea.AxisY.AutoRange)
            {
                return;
            }

            int slotsCount = 1 + (int)this.chart1.DefaultView.ChartArea.AxisX.ActualRange;
            double slotWidth = this.chart1.DefaultView.ChartArea.ActualWidth / slotsCount;
            var axisYSection = Math.Abs(this.chart1.DefaultView.ChartArea.AxisY.ConvertPhysicalUnitsToData(slotWidth) - this.chart1.DefaultView.ChartArea.AxisY.ConvertPhysicalUnitsToData(0));

            double actualYMin = this.chart1.DefaultView.ChartArea.AxisY.ActualMinValue;
            double actualYMax = this.chart1.DefaultView.ChartArea.AxisY.ActualMaxValue;
            double actualStep = this.chart1.DefaultView.ChartArea.AxisY.ActualStep;

            double diameter = 0;
            for (int i = 0; diameter - actualStep < axisYSection; i++)
            {
                diameter = i * actualStep;
            }

            double min = this.chart1.DefaultView.ChartArea.DataSeries[0].Min(dp => dp.YValue);
            double max = this.chart1.DefaultView.ChartArea.DataSeries[0].Max(dp => dp.YValue);

            bool shouldExpandMin = false;
            bool shouldExpandMax = false;

            if (min < actualYMin + diameter)
            {
                shouldExpandMin = true;
            }
            if (actualYMax - diameter < max)
            {
                shouldExpandMax = true;
            }

            if (shouldExpandMin || shouldExpandMax) 
            {
                this.chart1.DefaultView.ChartArea.AxisY.AutoRange = false;
                this.chart1.DefaultView.ChartArea.AxisY.Step = actualStep;
                this.chart1.DefaultView.ChartArea.AxisY.MinValue = actualYMin - (shouldExpandMin ? diameter : 0);
                this.chart1.DefaultView.ChartArea.AxisY.MaxValue = actualYMax + (shouldExpandMax ? diameter : 0);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var asd = this.chart1.DefaultView.ChartArea.AxisX.ConvertPhysicalUnitsToData(30) - this.chart1.DefaultView.ChartArea.AxisX.ConvertPhysicalUnitsToData(0);
        }
    }

    public class PlotInfo
    {
        public double YVal { get; set; }
        public double BubbleSizeVal { get; set; }
    }
}
